//+------------------------------------------------------------------+
//|                                          HL channel breakout.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window



extern int min_bars1=10;                   //minimalus baru skaicius -   
extern double ch_max1=45;                   //Maksimalus leidziamas kanalo auksti -    

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i, t,k=0;
   double zz_ch=0, new_zz_ch=0;                                                  //   
   double PriceHigh=0, PriceLow=0;                                                      //    ()                                                                
                                                            //              
   for(k=min_bars1; k<100000; k++)                                           //   
    {
         
        PriceHigh = High[Highest(NULL, 0, MODE_HIGH, k, 0)];
        PriceLow = Low [Lowest (NULL, 0, MODE_LOW , k,0)];                   
            if(PriceHigh-PriceLow<ch_max1*Point)           
               {
                  SetTLine(Red,    "DNLine"+min_bars1+Time[0]+ch_max1,    Time[k], PriceLow, Time[0], PriceLow, false, 0, 3);           //             
                  SetTLine(Blue,   "UPLine"+min_bars1+Time[0]+ch_max1,    Time[k], PriceHigh, Time[0], PriceHigh, false, 0, 3);          //    
                  SetTLine(Red,    "DN161Line"+min_bars1+Time[0]+ch_max1, Time[k], PriceLow-((PriceHigh-PriceLow)*0.61), Time[0], PriceLow-((PriceHigh-PriceLow)*0.61), false, 1, 1);                
                  SetTLine(Blue,   "UP161Line"+min_bars1+Time[0]+ch_max1, Time[k], PriceHigh+((PriceHigh-PriceLow)*0.61), Time[0], PriceHigh+((PriceHigh-PriceLow)*0.61), false, 1, 1);   
                  SetTLine(White,  "DN23Line"+min_bars1+Time[0]+ch_max1,  Time[k], PriceLow+((PriceHigh-PriceLow)*0.236), Time[0], PriceLow+((PriceHigh-PriceLow)*0.236), false, 1, 1);         
                  SetTLine(White,  "UP61Line"+min_bars1+Time[0]+ch_max1,  Time[k], PriceHigh-((PriceHigh-PriceLow)*0.236), Time[0], PriceHigh-((PriceHigh-PriceLow)*0.236), false, 1, 1);
                  SetTLine(White,  "DN36Line"+min_bars1+Time[0]+ch_max1,  Time[k], PriceLow+((PriceHigh-PriceLow)*0.362), Time[0], PriceLow+((PriceHigh-PriceLow)*0.362), false, 1, 1);         
                  SetTLine(White,  "UP74Line"+min_bars1+Time[0]+ch_max1,  Time[k], PriceHigh-((PriceHigh-PriceLow)*0.362), Time[0], PriceHigh-((PriceHigh-PriceLow)*0.362), false, 1, 1);         
                  //if(GlobalVariableCheck("H"))         GlobalVariableSet("H",PriceHigh);
                  //if(GlobalVariableCheck("L"))         GlobalVariableSet("L",PriceLow);  
               }
            else break;                  
    }   
    //VisualDoubleToText("h", "H", 50,GlobalVariableGet("H"), 4);
    //VisualDoubleToText("l", "L", 65,GlobalVariableGet("L"), 4);
    //VisualDoubleToText("c", "close", 80,Close[0], 4);          
    /*if (GlobalVariableGet("H") < Close[0]) 
      {
          ObjectCreate("Buy", OBJ_ARROW, 0, Time[0], GlobalVariableGet("H"));
          ObjectSet("Buy", OBJPROP_ARROWCODE, 233);
          ObjectSet("Buy", OBJPROP_COLOR, Blue);
      }  
    if (GlobalVariableGet("L") > Close[0]) 
      {
          ObjectCreate("Sell", OBJ_ARROW, 0, Time[0], GlobalVariableGet("L"));
           ObjectSet("Sell", OBJPROP_ARROWCODE, 234);
           ObjectSet("Sell", OBJPROP_COLOR, Red);
      }*/                
return(0);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}

//---------------------------------------------------------------------
//  Vizualizacija
//     
//-------------------------------------------------------------------- 
 int VisualDoubleToText(string name, string text, int y,double param, int digit )
 {  
            ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name, text,12, "Verdana", White );
            ObjectSet(name, OBJPROP_XDISTANCE, 20);
            ObjectSet(name, OBJPROP_YDISTANCE, y);
            ObjectSet(name, OBJPROP_CORNER, 0); 
            ObjectCreate(name+"skaicius", OBJ_LABEL, 0, 0, 0);
            ObjectSetText(name+"skaicius", DoubleToStr(param,digit),12, "Verdana", White );
            ObjectSet(name+"skaicius", OBJPROP_XDISTANCE, 200);
            ObjectSet(name+"skaicius", OBJPROP_YDISTANCE, y);
            ObjectSet(name+"skaicius", OBJPROP_CORNER, 0); 
 }
 

